<template>
    <div>
        <button type="button" v-on:click="logEvent('Button (Normal)', $event)">
            Button (Normal)
        </button>

        <button type="button" v-on:click.once="logEvent('Button (Once)', $event)">
            Button (Once)
        </button>

        <input type="text" v-on:input="logEvent('Text Input', $event)" />

        <input
            v-on:keydown.prevent="logEvent('Text KeyDown', $event)"
            type="text"
        />

        <div
            class="parent"
            v-on:click="logEvent('Parent Click', $event)"
            v-on:click.self="logEvent('Parent Self Click', $event)"
        >
            Parent
            <div class="child" v-on:click="logEvent('Child Click', $event)">
                Child Click
            </div>
            <div class="child" v-on:capture="logEvent('Child Capture', $event)">
                Child Capture
            </div>
            <div
                class="child"
                v-on:click.stop="
                    logEvent('Child Click Stop Propagation', $event)
                "
            >
                Child Click Stop Propagation
            </div>
        </div>
    </div>
</template>

<script>
export default {
    methods: {
        logEvent(name, event) {
            console.log(name, event);
        }
    }
};
</script>

<style>
button,
input {
    display: block;
    margin: 1rem;
}

div {
    border: 1px solid black;
    margin: 1rem;
    padding: 1rem;
}

.parent {
    background-color: yellow;
}

.child {
    background-color: green;
}
</style>
